#include "m3kte.h"
#include "ui_m3kte.h"

#include "settingsdialog.h"
#include "writeregistermodel.h"

#include <QModbusTcpClient>
#include <QModbusRtuSerialMaster>
#include <QStandardItemModel>
#include <QStatusBar>
#include <QUrl>

//1024 768
//Ширина колбы - уже
M3KTE::M3KTE(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::M3KTE)
{
    ui->setupUi(this);

    //Массив указателей на индикаторы напряжения топливных элементов
    {
        int i = 0;
        m[i++] = ui->FuelCellVoltageBar_1;
        m[i++] = ui->FuelCellVoltageBar_2;
        m[i++] = ui->FuelCellVoltageBar_3;
        m[i++] = ui->FuelCellVoltageBar_4;
        m[i++] = ui->FuelCellVoltageBar_5;
        m[i++] = ui->FuelCellVoltageBar_6;
        m[i++] = ui->FuelCellVoltageBar_7;
        m[i++] = ui->FuelCellVoltageBar_8;
        m[i++] = ui->FuelCellVoltageBar_9;
        m[i++] = ui->FuelCellVoltageBar_10;
        m[i++] = ui->FuelCellVoltageBar_11;
        m[i++] = ui->FuelCellVoltageBar_12;
        m[i++] = ui->FuelCellVoltageBar_13;
        m[i++] = ui->FuelCellVoltageBar_14;
        m[i++] = ui->FuelCellVoltageBar_15;
        m[i++] = ui->FuelCellVoltageBar_16;
        m[i++] = ui->FuelCellVoltageBar_17;
        m[i++] = ui->FuelCellVoltageBar_18;
        m[i++] = ui->FuelCellVoltageBar_19;
        m[i++] = ui->FuelCellVoltageBar_20;
        m[i++] = ui->FuelCellVoltageBar_21;
        m[i++] = ui->FuelCellVoltageBar_22;
        m[i++] = ui->FuelCellVoltageBar_23;
        m[i++] = ui->FuelCellVoltageBar_24;
        m[i++] = ui->FuelCellVoltageBar_25;
        m[i++] = ui->FuelCellVoltageBar_26;
        m[i++] = ui->FuelCellVoltageBar_27;
        m[i++] = ui->FuelCellVoltageBar_28;
        m[i++] = ui->FuelCellVoltageBar_29;
        m[i++] = ui->FuelCellVoltageBar_30;
        m[i++] = ui->FuelCellVoltageBar_31;
        m[i++] = ui->FuelCellVoltageBar_32;
        m[i++] = ui->FuelCellVoltageBar_33;
        m[i++] = ui->FuelCellVoltageBar_34;
        m[i++] = ui->FuelCellVoltageBar_35;
        m[i++] = ui->FuelCellVoltageBar_36;
        m[i++] = ui->FuelCellVoltageBar_37;
        m[i++] = ui->FuelCellVoltageBar_38;
        m[i++] = ui->FuelCellVoltageBar_39;
        m[i++] = ui->FuelCellVoltageBar_40;
        m[i++] = ui->FuelCellVoltageBar_41;
        m[i++] = ui->FuelCellVoltageBar_42;
        m[i++] = ui->FuelCellVoltageBar_43;
        m[i++] = ui->FuelCellVoltageBar_44;
        m[i++] = ui->FuelCellVoltageBar_45;
        m[i++] = ui->FuelCellVoltageBar_46;
        m[i++] = ui->FuelCellVoltageBar_47;
        m[i++] = ui->FuelCellVoltageBar_48;
        m[i++] = ui->FuelCellVoltageBar_49;
        m[i++] = ui->FuelCellVoltageBar_50;
        m[i++] = ui->FuelCellVoltageBar_51;
        m[i++] = ui->FuelCellVoltageBar_52;
        m[i++] = ui->FuelCellVoltageBar_53;
        m[i++] = ui->FuelCellVoltageBar_54;
        m[i++] = ui->FuelCellVoltageBar_55;
        m[i++] = ui->FuelCellVoltageBar_56;
        m[i++] = ui->FuelCellVoltageBar_57;
        m[i++] = ui->FuelCellVoltageBar_58;
        m[i++] = ui->FuelCellVoltageBar_59;
        m[i++] = ui->FuelCellVoltageBar_60;
        m[i++] = ui->FuelCellVoltageBar_61;
        m[i++] = ui->FuelCellVoltageBar_62;
        m[i++] = ui->FuelCellVoltageBar_63;
        m[i++] = ui->FuelCellVoltageBar_64;
        m[i++] = ui->FuelCellVoltageBar_65;
        m[i++] = ui->FuelCellVoltageBar_66;
        m[i++] = ui->FuelCellVoltageBar_67;
        m[i++] = ui->FuelCellVoltageBar_68;
        m[i++] = ui->FuelCellVoltageBar_69;
        m[i++] = ui->FuelCellVoltageBar_70;
        m[i++] = ui->FuelCellVoltageBar_71;
        m[i++] = ui->FuelCellVoltageBar_72;
        m[i++] = ui->FuelCellVoltageBar_73;
        m[i++] = ui->FuelCellVoltageBar_74;
        m[i++] = ui->FuelCellVoltageBar_75;
        m[i++] = ui->FuelCellVoltageBar_76;
        m[i++] = ui->FuelCellVoltageBar_77;
        m[i++] = ui->FuelCellVoltageBar_78;
        m[i++] = ui->FuelCellVoltageBar_79;
        m[i++] = ui->FuelCellVoltageBar_80;
        m[i++] = ui->FuelCellVoltageBar_81;
        m[i++] = ui->FuelCellVoltageBar_82;
        m[i++] = ui->FuelCellVoltageBar_83;
        m[i++] = ui->FuelCellVoltageBar_84;
        m[i++] = ui->FuelCellVoltageBar_85;
        m[i++] = ui->FuelCellVoltageBar_86;
        m[i++] = ui->FuelCellVoltageBar_87;
        m[i++] = ui->FuelCellVoltageBar_88;
        m[i++] = ui->FuelCellVoltageBar_89;
        m[i++] = ui->FuelCellVoltageBar_90;
        m[i++] = ui->FuelCellVoltageBar_91;
        m[i++] = ui->FuelCellVoltageBar_92;
        m[i++] = ui->FuelCellVoltageBar_93;
        m[i++] = ui->FuelCellVoltageBar_94;
        m[i++] = ui->FuelCellVoltageBar_95;
        m[i++] = ui->FuelCellVoltageBar_96;
        m[i++] = ui->FuelCellVoltageBar_97;
        m[i++] = ui->FuelCellVoltageBar_98;
        m[i++] = ui->FuelCellVoltageBar_99;
        m[i++] = ui->FuelCellVoltageBar_100;
        m[i++] = ui->FuelCellVoltageBar_101;
        m[i++] = ui->FuelCellVoltageBar_102;
        m[i++] = ui->FuelCellVoltageBar_103;
        m[i++] = ui->FuelCellVoltageBar_104;
        m[i++] = ui->FuelCellVoltageBar_105;
        m[i++] = ui->FuelCellVoltageBar_106;
        m[i++] = ui->FuelCellVoltageBar_107;
        m[i++] = ui->FuelCellVoltageBar_108;
        m[i++] = ui->FuelCellVoltageBar_109;
        m[i++] = ui->FuelCellVoltageBar_110;
        m[i++] = ui->FuelCellVoltageBar_111;
        m[i++] = ui->FuelCellVoltageBar_112;
        m[i++] = ui->FuelCellVoltageBar_113;
        m[i++] = ui->FuelCellVoltageBar_114;
        m[i++] = ui->FuelCellVoltageBar_115;
        m[i++] = ui->FuelCellVoltageBar_116;
        m[i++] = ui->FuelCellVoltageBar_117;
        m[i++] = ui->FuelCellVoltageBar_118;
        m[i++] = ui->FuelCellVoltageBar_119;
        m[i++] = ui->FuelCellVoltageBar_120;
        m[i++] = ui->FuelCellVoltageBar_121;
        m[i++] = ui->FuelCellVoltageBar_122;
        m[i++] = ui->FuelCellVoltageBar_123;
        m[i++] = ui->FuelCellVoltageBar_124;
        m[i++] = ui->FuelCellVoltageBar_125;
        m[i++] = ui->FuelCellVoltageBar_126;
        m[i++] = ui->FuelCellVoltageBar_127;
        m[i++] = ui->FuelCellVoltageBar_128;
        m[i++] = ui->FuelCellVoltageBar_129;
        m[i++] = ui->FuelCellVoltageBar_130;
        m[i++] = ui->FuelCellVoltageBar_131;
        m[i++] = ui->FuelCellVoltageBar_132;
        m[i++] = ui->FuelCellVoltageBar_133;
        m[i++] = ui->FuelCellVoltageBar_134;
        m[i++] = ui->FuelCellVoltageBar_135;
        m[i++] = ui->FuelCellVoltageBar_136;
        m[i++] = ui->FuelCellVoltageBar_137;
        m[i++] = ui->FuelCellVoltageBar_138;
        m[i++] = ui->FuelCellVoltageBar_139;
        m[i++] = ui->FuelCellVoltageBar_140;
        m[i++] = ui->FuelCellVoltageBar_141;
        m[i++] = ui->FuelCellVoltageBar_142;
        m[i++] = ui->FuelCellVoltageBar_143;
        m[i++] = ui->FuelCellVoltageBar_144;
        m[i++] = ui->FuelCellVoltageBar_145;
        m[i++] = ui->FuelCellVoltageBar_146;
        m[i++] = ui->FuelCellVoltageBar_147;
        m[i++] = ui->FuelCellVoltageBar_148;
        m[i++] = ui->FuelCellVoltageBar_149;
        m[i++] = ui->FuelCellVoltageBar_150;
        m[i++] = ui->FuelCellVoltageBar_151;
        m[i++] = ui->FuelCellVoltageBar_152;
        m[i++] = ui->FuelCellVoltageBar_153;
        m[i++] = ui->FuelCellVoltageBar_154;
        m[i++] = ui->FuelCellVoltageBar_155;
        m[i++] = ui->FuelCellVoltageBar_156;
        m[i++] = ui->FuelCellVoltageBar_157;
        m[i++] = ui->FuelCellVoltageBar_158;
        m[i++] = ui->FuelCellVoltageBar_159;
        m[i++] = ui->FuelCellVoltageBar_160;
        m[i++] = ui->FuelCellVoltageBar_161;
        m[i++] = ui->FuelCellVoltageBar_162;
        m[i++] = ui->FuelCellVoltageBar_163;
        m[i++] = ui->FuelCellVoltageBar_164;
        m[i++] = ui->FuelCellVoltageBar_165;
        m[i++] = ui->FuelCellVoltageBar_166;
        m[i++] = ui->FuelCellVoltageBar_167;
        m[i++] = ui->FuelCellVoltageBar_168;
        m[i++] = ui->FuelCellVoltageBar_169;
        m[i++] = ui->FuelCellVoltageBar_170;
        m[i++] = ui->FuelCellVoltageBar_171;
        m[i++] = ui->FuelCellVoltageBar_172;
        m[i++] = ui->FuelCellVoltageBar_173;
        m[i++] = ui->FuelCellVoltageBar_174;
        m[i++] = ui->FuelCellVoltageBar_175;
        m[i++] = ui->FuelCellVoltageBar_176;
        m[i++] = ui->FuelCellVoltageBar_177;
        m[i++] = ui->FuelCellVoltageBar_178;
        m[i++] = ui->FuelCellVoltageBar_179;
        m[i++] = ui->FuelCellVoltageBar_180;
        m[i++] = ui->FuelCellVoltageBar_181;
        m[i++] = ui->FuelCellVoltageBar_182;
        m[i++] = ui->FuelCellVoltageBar_183;
        m[i++] = ui->FuelCellVoltageBar_184;
        m[i++] = ui->FuelCellVoltageBar_185;
        m[i++] = ui->FuelCellVoltageBar_186;
        m[i++] = ui->FuelCellVoltageBar_187;
        m[i++] = ui->FuelCellVoltageBar_188;
        m[i++] = ui->FuelCellVoltageBar_189;
        m[i++] = ui->FuelCellVoltageBar_190;
        m[i++] = ui->FuelCellVoltageBar_191;
        m[i++] = ui->FuelCellVoltageBar_192;
        m[i++] = ui->FuelCellVoltageBar_193;
        m[i++] = ui->FuelCellVoltageBar_194;
        m[i++] = ui->FuelCellVoltageBar_195;
        m[i++] = ui->FuelCellVoltageBar_196;
        m[i++] = ui->FuelCellVoltageBar_197;
        m[i++] = ui->FuelCellVoltageBar_198;
        m[i++] = ui->FuelCellVoltageBar_199;
        m[i++] = ui->FuelCellVoltageBar_200;
        m[i++] = ui->FuelCellVoltageBar_201;
        m[i++] = ui->FuelCellVoltageBar_202;
        m[i++] = ui->FuelCellVoltageBar_203;
        m[i++] = ui->FuelCellVoltageBar_204;
        m[i++] = ui->FuelCellVoltageBar_205;
        m[i++] = ui->FuelCellVoltageBar_206;
        m[i++] = ui->FuelCellVoltageBar_207;
        m[i++] = ui->FuelCellVoltageBar_208;
        m[i++] = ui->FuelCellVoltageBar_209;
        m[i++] = ui->FuelCellVoltageBar_210;
        m[i++] = ui->FuelCellVoltageBar_211;
        m[i++] = ui->FuelCellVoltageBar_212;
        m[i++] = ui->FuelCellVoltageBar_213;
        m[i++] = ui->FuelCellVoltageBar_214;
        m[i++] = ui->FuelCellVoltageBar_215;
        m[i++] = ui->FuelCellVoltageBar_216;
        m[i++] = ui->FuelCellVoltageBar_217;
        m[i++] = ui->FuelCellVoltageBar_218;
        m[i++] = ui->FuelCellVoltageBar_219;
        m[i++] = ui->FuelCellVoltageBar_220;
        m[i++] = ui->FuelCellVoltageBar_221;
        m[i++] = ui->FuelCellVoltageBar_222;
        m[i++] = ui->FuelCellVoltageBar_223;
        m[i++] = ui->FuelCellVoltageBar_224;
        m[i++] = ui->FuelCellVoltageBar_225;
        m[i++] = ui->FuelCellVoltageBar_226;
        m[i++] = ui->FuelCellVoltageBar_227;
        m[i++] = ui->FuelCellVoltageBar_228;
        m[i++] = ui->FuelCellVoltageBar_229;
        m[i++] = ui->FuelCellVoltageBar_230;
        m[i++] = ui->FuelCellVoltageBar_231;
        m[i++] = ui->FuelCellVoltageBar_232;
        m[i++] = ui->FuelCellVoltageBar_233;
        m[i++] = ui->FuelCellVoltageBar_234;
        m[i++] = ui->FuelCellVoltageBar_235;
        m[i++] = ui->FuelCellVoltageBar_236;
        m[i++] = ui->FuelCellVoltageBar_237;
        m[i++] = ui->FuelCellVoltageBar_238;
        m[i++] = ui->FuelCellVoltageBar_239;
        m[i++] = ui->FuelCellVoltageBar_240;
        m[i++] = ui->FuelCellVoltageBar_241;
        m[i++] = ui->FuelCellVoltageBar_242;
        m[i++] = ui->FuelCellVoltageBar_243;
        m[i++] = ui->FuelCellVoltageBar_244;
        m[i++] = ui->FuelCellVoltageBar_245;
        m[i++] = ui->FuelCellVoltageBar_246;
        m[i++] = ui->FuelCellVoltageBar_247;
        m[i++] = ui->FuelCellVoltageBar_248;
        m[i++] = ui->FuelCellVoltageBar_249;
        m[i++] = ui->FuelCellVoltageBar_250;
        m[i++] = ui->FuelCellVoltageBar_251;
        m[i++] = ui->FuelCellVoltageBar_252;
        m[i++] = ui->FuelCellVoltageBar_253;
        m[i++] = ui->FuelCellVoltageBar_254;
        m[i++] = ui->FuelCellVoltageBar_255;
        m[i++] = ui->FuelCellVoltageBar_256;
        m[i++] = ui->FuelCellVoltageBar_257;
        m[i++] = ui->FuelCellVoltageBar_258;
        m[i++] = ui->FuelCellVoltageBar_259;
        m[i++] = ui->FuelCellVoltageBar_260;
        m[i++] = ui->FuelCellVoltageBar_261;
        m[i++] = ui->FuelCellVoltageBar_262;
        m[i++] = ui->FuelCellVoltageBar_263;
        m[i++] = ui->FuelCellVoltageBar_264;
        m[i++] = ui->FuelCellVoltageBar_265;
        m[i++] = ui->FuelCellVoltageBar_266;
        m[i++] = ui->FuelCellVoltageBar_267;
        m[i++] = ui->FuelCellVoltageBar_268;
        m[i++] = ui->FuelCellVoltageBar_269;
        m[i++] = ui->FuelCellVoltageBar_270;
        m[i++] = ui->FuelCellVoltageBar_271;
        m[i++] = ui->FuelCellVoltageBar_272;
        m[i++] = ui->FuelCellVoltageBar_273;
        m[i++] = ui->FuelCellVoltageBar_274;
        m[i++] = ui->FuelCellVoltageBar_275;
        m[i++] = ui->FuelCellVoltageBar_276;
        m[i++] = ui->FuelCellVoltageBar_277;
        m[i++] = ui->FuelCellVoltageBar_278;
        m[i++] = ui->FuelCellVoltageBar_279;
        m[i++] = ui->FuelCellVoltageBar_280;
        m[i++] = ui->FuelCellVoltageBar_281;
        m[i++] = ui->FuelCellVoltageBar_282;
        m[i++] = ui->FuelCellVoltageBar_283;
        m[i++] = ui->FuelCellVoltageBar_284;
        m[i++] = ui->FuelCellVoltageBar_285;
        m[i++] = ui->FuelCellVoltageBar_286;
        m[i++] = ui->FuelCellVoltageBar_287;
        m[i++] = ui->FuelCellVoltageBar_288;
        m[i++] = ui->FuelCellVoltageBar_289;
        m[i++] = ui->FuelCellVoltageBar_290;
        m[i++] = ui->FuelCellVoltageBar_291;
        m[i++] = ui->FuelCellVoltageBar_292;
        m[i++] = ui->FuelCellVoltageBar_293;
        m[i++] = ui->FuelCellVoltageBar_294;
        m[i++] = ui->FuelCellVoltageBar_295;
        m[i++] = ui->FuelCellVoltageBar_296;
        m[i++] = ui->FuelCellVoltageBar_297;
        m[i++] = ui->FuelCellVoltageBar_298;
        m[i++] = ui->FuelCellVoltageBar_299;
        m[i++] = ui->FuelCellVoltageBar_300;
        m[i++] = ui->FuelCellVoltageBar_301;
        m[i++] = ui->FuelCellVoltageBar_302;
        m[i++] = ui->FuelCellVoltageBar_303;
        m[i++] = ui->FuelCellVoltageBar_304;
        m[i++] = ui->FuelCellVoltageBar_305;
        m[i++] = ui->FuelCellVoltageBar_306;
        m[i++] = ui->FuelCellVoltageBar_307;
        m[i++] = ui->FuelCellVoltageBar_308;
        m[i++] = ui->FuelCellVoltageBar_309;
        m[i++] = ui->FuelCellVoltageBar_310;
        m[i++] = ui->FuelCellVoltageBar_311;
        m[i++] = ui->FuelCellVoltageBar_312;
        m[i++] = ui->FuelCellVoltageBar_313;
        m[i++] = ui->FuelCellVoltageBar_314;
        m[i++] = ui->FuelCellVoltageBar_315;
        m[i++] = ui->FuelCellVoltageBar_316;
        m[i++] = ui->FuelCellVoltageBar_317;
        m[i++] = ui->FuelCellVoltageBar_318;
        m[i++] = ui->FuelCellVoltageBar_319;
        m[i++] = ui->FuelCellVoltageBar_320;
    }
    /*QGroupBox *FCB[85];
    {
        int i = 0;
        FCB[i++] = ui->FuelCellBox_1;
        FCB[i++] = ui->FuelCellBox_2;
        FCB[i++] = ui->FuelCellBox_3;
        FCB[i++] = ui->FuelCellBox_4;
        FCB[i++] = ui->FuelCellBox_5;
        FCB[i++] = ui->FuelCellBox_6;
        FCB[i++] = ui->FuelCellBox_7;
        FCB[i++] = ui->FuelCellBox_8;
        FCB[i++] = ui->FuelCellBox_9;
        FCB[i++] = ui->FuelCellBox_10;
        FCB[i++] = ui->FuelCellBox_11;
        FCB[i++] = ui->FuelCellBox_12;
        FCB[i++] = ui->FuelCellBox_13;
        FCB[i++] = ui->FuelCellBox_14;
        FCB[i++] = ui->FuelCellBox_15;
        FCB[i++] = ui->FuelCellBox_16;
        FCB[i++] = ui->FuelCellBox_17;
        FCB[i++] = ui->FuelCellBox_18;
        FCB[i++] = ui->FuelCellBox_19;
        FCB[i++] = ui->FuelCellBox_20;
        FCB[i++] = ui->FuelCellBox_21;
        FCB[i++] = ui->FuelCellBox_22;
        FCB[i++] = ui->FuelCellBox_23;
        FCB[i++] = ui->FuelCellBox_24;
        FCB[i++] = ui->FuelCellBox_25;
        FCB[i++] = ui->FuelCellBox_26;
        FCB[i++] = ui->FuelCellBox_27;
        FCB[i++] = ui->FuelCellBox_28;
        FCB[i++] = ui->FuelCellBox_29;
        FCB[i++] = ui->FuelCellBox_30;
        FCB[i++] = ui->FuelCellBox_31;
        FCB[i++] = ui->FuelCellBox_32;
        FCB[i++] = ui->FuelCellBox_33;
        FCB[i++] = ui->FuelCellBox_34;
        FCB[i++] = ui->FuelCellBox_35;
        FCB[i++] = ui->FuelCellBox_36;
        FCB[i++] = ui->FuelCellBox_37;
        FCB[i++] = ui->FuelCellBox_38;
        FCB[i++] = ui->FuelCellBox_39;
        FCB[i++] = ui->FuelCellBox_40;
        FCB[i++] = ui->FuelCellBox_41;
        FCB[i++] = ui->FuelCellBox_42;
        FCB[i++] = ui->FuelCellBox_43;
        FCB[i++] = ui->FuelCellBox_44;
        FCB[i++] = ui->FuelCellBox_45;
        FCB[i++] = ui->FuelCellBox_46;
        FCB[i++] = ui->FuelCellBox_47;
        FCB[i++] = ui->FuelCellBox_48;
        FCB[i++] = ui->FuelCellBox_49;
        FCB[i++] = ui->FuelCellBox_50;
        FCB[i++] = ui->FuelCellBox_51;
        FCB[i++] = ui->FuelCellBox_52;
        FCB[i++] = ui->FuelCellBox_53;
        FCB[i++] = ui->FuelCellBox_54;
        FCB[i++] = ui->FuelCellBox_55;
        FCB[i++] = ui->FuelCellBox_56;
        FCB[i++] = ui->FuelCellBox_57;
        FCB[i++] = ui->FuelCellBox_58;
        FCB[i++] = ui->FuelCellBox_59;
        FCB[i++] = ui->FuelCellBox_60;
        FCB[i++] = ui->FuelCellBox_61;
        FCB[i++] = ui->FuelCellBox_62;
        FCB[i++] = ui->FuelCellBox_63;
        FCB[i++] = ui->FuelCellBox_64;
        FCB[i++] = ui->FuelCellBox_65;
        FCB[i++] = ui->FuelCellBox_66;
        FCB[i++] = ui->FuelCellBox_67;
        FCB[i++] = ui->FuelCellBox_68;
        FCB[i++] = ui->FuelCellBox_69;
        FCB[i++] = ui->FuelCellBox_70;
        FCB[i++] = ui->FuelCellBox_71;
        FCB[i++] = ui->FuelCellBox_72;
        FCB[i++] = ui->FuelCellBox_73;
        FCB[i++] = ui->FuelCellBox_74;
        FCB[i++] = ui->FuelCellBox_75;
        FCB[i++] = ui->FuelCellBox_76;
        FCB[i++] = ui->FuelCellBox_77;
        FCB[i++] = ui->FuelCellBox_78;
        FCB[i++] = ui->FuelCellBox_79;
        FCB[i++] = ui->FuelCellBox_80;
        FCB[i++] = ui->FuelCellBox_81;
        FCB[i++] = ui->FuelCellBox_82;
        FCB[i++] = ui->FuelCellBox_83;
        FCB[i++] = ui->FuelCellBox_84;
        FCB[i++] = ui->FuelCellBox_85;
    }*/

    m_settingsDialog = new SettingsDialog(this);

    ui->writeTable->addItem(tr("Exceptions"), QModbusDataUnit::Coils);
    ui->writeTable->addItem(tr("Warnings"), QModbusDataUnit::HoldingRegisters);
    ui->writeTable->addItem(tr("Accidents"), QModbusDataUnit::HoldingRegisters);

    for(int i = 0; i < 4; i++)
    {
        Boards[i].ModbusModelCoil = new WriteRegisterModel(this, 85 - (i/3*20), false);
        Boards[i].ModbusModelCoil->setStartAddress(0);
        Boards[i].ModbusModelCoil->setNumberOfValues(QString::number(85-(i/3*20)));
        Boards[i].ModbusModelHoldingReg = new WriteRegisterModel(this, (85 - (i/3*20))*2, true);
        Boards[i].ModbusModelHoldingReg->setStartAddress(0);
        Boards[i].ModbusModelHoldingReg->setNumberOfValues(QString::number(85-(i/3*20)));
    }

    m_deviceSettingsDialog = new DeviceSettingsDialog(this);

    modbusDevice = new QModbusRtuSerialMaster(this);

    Boards[0].boardScanners = new QTimer();
    Boards[1].boardScanners = new QTimer();
    Boards[2].boardScanners = new QTimer();
    Boards[3].boardScanners = new QTimer();

    Boards[0].boardScanners->setSingleShot(true);
    Boards[1].boardScanners->setSingleShot(true);
    Boards[2].boardScanners->setSingleShot(true);
    Boards[3].boardScanners->setSingleShot(true);

    connect(Boards[0].boardScanners, &QTimer::timeout, this, &M3KTE::firstBoardScan);
    connect(Boards[1].boardScanners, &QTimer::timeout, this, &M3KTE::secondBoardScan);
    connect(Boards[2].boardScanners, &QTimer::timeout, this, &M3KTE::thirdBoardScan);
    connect(Boards[3].boardScanners, &QTimer::timeout, this, &M3KTE::fourthBoardScan);

    Boards[0].adr = 1;
    Boards[1].adr = 2;
    Boards[2].adr = 3;
    Boards[3].adr = 4;

    ui->BSM_Warning->setEnabled(false);
    ui->BSM_Accident->setEnabled(false);
    ui->BSM_WorkInProgress->setEnabled(false);

    initActions();

    ui->BST_Off->setChecked(true);

    ui->boardSelectBox->setCurrentIndex(0);
    ui->writeTable->setCurrentIndex(0);
    changeTable(0, 0);

    for (int i = 0; i < 4; i++) {
        statusM3KTE.Warnings[i] = false;
        statusM3KTE.Accidents[i] = false;
    }

    for(int i = 0; i<320; i++)
    {
        m[i]->setValue(3);
        QString style_fc_off = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(30) + ", 30, 30, 30%);} ";
        m[i]->setStyleSheet(style_fc_off);
    }
    debug();

    //Вызов окна настройки подключения

    //Вызов окна настройки устройства

}

M3KTE::~M3KTE()
{
    delete ui;
}

void M3KTE::debug()
{
    srand(time(0));
    for(int i = 0; i < 320; i++)
    {
        m[i]->setTextVisible(true);
        m[i]->setMinimumSize(25, 25);
        m[i]->setMaximumSize(25, 25);
        m[i]->resize(25, 25);
        m[i]->setAlignment(Qt::AlignCenter);
        m[i]->setFormat(QString("%1").arg((i%85+1)));
//        int j = rand()%4;
//        if(j!=3) j=rand()%4;
//        m[i]->setValue(j);
//        QString style_fc = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(j*50-50) + ", 255, 255, 100%);} ";
//        QString style_fc_off = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(30) + ", 30, 30, 30%);} ";
//        m[i]->setStyleSheet(style_fc);

//        switch (j) {
//        case 1:
//        {
//            m[i]->setStatusTip(QString("П%1 ТЭ%2: Аварийный уровень напряжения.").arg(QString::number(i/85+1), QString::number(i%85)));
//            break;
//        }
//        case 2:
//        {
//            m[i]->setStatusTip(QString("П%1 ТЭ%2: Предупредительный уровень напряжения.").arg(QString::number(i/85+1), QString::number(i%85)));
//            break;
//        }
//        case 3:
//        {
//            m[i]->setStatusTip(QString("П%1 ТЭ%2: Уровень напряжения в норме.").arg(QString::number(i/85+1), QString::number(i%85)));
//            break;
//        }
//        case 0:
//            m[i]->setStatusTip(QString("П%1 ТЭ%2: Топливный Элемент не учитывается.").arg(QString::number(i/85+1), QString::number(i%85)));
//            m[i]->setStyleSheet(style_fc_off);
//            m[i]->setValue(3);
//            break;
//        }
    }
}


void M3KTE::initActions()
{
    ui->ConnectionMenuConnect->setEnabled(true);
    ui->ConnectionMenuDisconnect->setEnabled(false);
    ui->ConnectionMenuSettings->setEnabled(true);

    connect(ui->ConnectionMenuConnect, &QAction::triggered,
            this, &M3KTE::onConnectClicked);
    connect(ui->ConnectionMenuDisconnect, &QAction::triggered,
            this, &M3KTE::onConnectClicked);
    connect(ui->readButton, &QPushButton::clicked,
            this, &M3KTE::onReadButtonClicked);
    connect(ui->writeButton, &QPushButton::clicked,
            this, &M3KTE::onWriteButtonClicked);
    connect(ui->boardSelectBox, QOverload<int>::of(&QComboBox::currentIndexChanged),
            this, &M3KTE::onSelectedBoardChanged);
    connect(ui->writeTable, QOverload<int>::of(&QComboBox::currentIndexChanged),
            this, &M3KTE::onWriteTableChanged);

    connect(ui->ConnectionMenuSettings, &QAction::triggered, m_settingsDialog, &QDialog::show);
    connect(ui->M3kteMenuSettings, &QAction::triggered, m_deviceSettingsDialog, &QDialog::show);
}

void M3KTE::onConnectClicked()
{
    if (!modbusDevice)
        return;

    statusBar()->clearMessage();
    if (modbusDevice->state() != QModbusDevice::ConnectedState) {
            modbusDevice->setConnectionParameter(QModbusDevice::SerialPortNameParameter,
                m_settingsDialog->settings().portName);
#if QT_CONFIG(modbus_serialport)
            modbusDevice->setConnectionParameter(QModbusDevice::SerialParityParameter,
                m_settingsDialog->settings().parity);
            modbusDevice->setConnectionParameter(QModbusDevice::SerialBaudRateParameter,
                m_settingsDialog->settings().baud);
            modbusDevice->setConnectionParameter(QModbusDevice::SerialDataBitsParameter,
                m_settingsDialog->settings().dataBits);
            modbusDevice->setConnectionParameter(QModbusDevice::SerialStopBitsParameter,
                m_settingsDialog->settings().stopBits);
#endif
        modbusDevice->setTimeout(m_settingsDialog->settings().responseTime);
        modbusDevice->setNumberOfRetries(m_settingsDialog->settings().numberOfRetries);
        if (!modbusDevice->connectDevice()) {
            statusBar()->showMessage(tr("Connect failed: ") + modbusDevice->errorString(), 5000);
        } else {
            ui->ConnectionMenuConnect->setEnabled(false);
            ui->ConnectionMenuDisconnect->setEnabled(true);

            if(pingNetworkDevices())
            {
                unsigned tmp_adr[4];
                for (int i = 0; i < 4; i++) {
                    tmp_adr[i] = Boards[i].adr;
                }

                m_deviceSettingsDialog->updateSettingsAfterConnection(m_settingsDialog->settings().baud, m_settingsDialog->settings().parity, tmp_adr);

                ui->boardSelectBox->setCurrentIndex(0);
                ui->writeTable->setCurrentIndex(0);
                changeTable(0, 0);

                ui->BST_Off->setChecked(false);
                ui->BST_On->setChecked(true);

                ui->BSM_Warning->setEnabled(true);
                ui->BSM_Accident->setEnabled(true);
                ui->BSM_WorkInProgress->setEnabled(true);
                ui->BSM_WorkInProgress->setChecked(true);
            }
            //Опрос устройств
        }
    } else {
        modbusDevice->disconnectDevice();
        ui->ConnectionMenuConnect->setEnabled(true);
        ui->ConnectionMenuDisconnect->setEnabled(false);
        ui->BST_Off->setChecked(true);
        ui->BST_On->setChecked(false);

        ui->BSM_Warning->setChecked(false);
        ui->BSM_Accident->setChecked(false);
        ui->BSM_WorkInProgress->setChecked(false);

        ui->BSM_Warning->setEnabled(false);
        ui->BSM_Accident->setEnabled(false);
        ui->BSM_WorkInProgress->setEnabled(false);
    }
}

void M3KTE::onReadButtonClicked()
{
    if (!modbusDevice)
        return;
    //ui->readValue->clear();
    statusBar()->clearMessage();

    if (auto *reply = modbusDevice->sendReadRequest(readRequest(), Boards[ui->boardSelectBox->currentIndex()].adr)) {
        if (!reply->isFinished())
            connect(reply, &QModbusReply::finished, this, &M3KTE::onReadReady);
        else
            delete reply; // broadcast replies return immediately
    } else {
        statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
    }
//    if (auto *reply = modbusDevice->sendReadRequest(readRequest(), ui->serverEdit->value())) {
//        if (!reply->isFinished())
//            connect(reply, &QModbusReply::finished, this, &M3KTE::onReadReady);
//        else
//            delete reply; // broadcast replies return immediately
//    } else {
//        statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
//    }
//    if (auto *reply = modbusDevice->sendReadRequest(readRequest(), ui->serverEdit->value())) {
//        if (!reply->isFinished())
//            connect(reply, &QModbusReply::finished, this, &M3KTE::onReadReady);
//        else
//            delete reply; // broadcast replies return immediately
//    } else {
//        statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
//    }
}

void M3KTE::onReadReady()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    if (!reply)
        return;

    if (reply->error() == QModbusDevice::NoError) {
        const QModbusDataUnit unit = reply->result();
        int Adr = 255;
        for(int i = 0; i < 4; i++)
        {
            if(Boards[i].adr==reply->serverAddress())
            {
                Adr = i;
                break;
            }
        }
        for (int i = unit.startAddress(), total = int(unit.valueCount()); i < total; ++i) {
            //ui->readValue->addItem(entry);
            if(unit.registerType() == QModbusDataUnit::Coils)
            {
                //QStandardItem *item = ui->writeValueTable->model()->item
                if(unit.value(i)==1)
                    Boards[Adr].ModbusModelCoil->setData(ui->writeValueTable->model()->index(i, 2), Qt::Checked, Qt::CheckStateRole);
                else
                   Boards[Adr].ModbusModelCoil->setData(ui->writeValueTable->model()->index(i, 2), Qt::Unchecked, Qt::CheckStateRole);
            }
            else if(unit.registerType() == QModbusDataUnit::HoldingRegisters)
            {
                Boards[Adr].ModbusModelHoldingReg->setData(ui->writeValueTable->model()->index(i, 3), QString::number(unit.value(i), 16), Qt::EditRole);
            }
        }
    } else if (reply->error() == QModbusDevice::ProtocolError) {
        statusBar()->showMessage(tr("Read response error: %1 (Mobus exception: 0x%2)").
                                    arg(reply->errorString()).
                                    arg(reply->rawResult().exceptionCode(), -1, 16), 5000);
    } else {
        statusBar()->showMessage(tr("Read response error: %1 (code: 0x%2)").
                                    arg(reply->errorString()).
                                    arg(reply->error(), -1, 16), 5000);
    }

    reply->deleteLater();
}

void M3KTE::onWriteButtonClicked()
{
    if (!modbusDevice)
        return;
    statusBar()->clearMessage();

    QModbusDataUnit writeUnit = writeRequest();
    QModbusDataUnit::RegisterType table = writeUnit.registerType();
    for (int i = 0, total = int(writeUnit.valueCount()); i < total; ++i) {
        if (table == QModbusDataUnit::Coils)
            writeUnit.setValue(i, Boards[ui->boardSelectBox->currentIndex()].ModbusModelCoil->m_coils[i + writeUnit.startAddress()]);
        else
            writeUnit.setValue(i, Boards[ui->boardSelectBox->currentIndex()].ModbusModelHoldingReg->m_holdingRegisters[i + writeUnit.startAddress()]);
    }

    if (auto *reply = modbusDevice->sendWriteRequest(writeUnit, Boards[ui->boardSelectBox->currentIndex()].adr)) {
        if (!reply->isFinished()) {
            connect(reply, &QModbusReply::finished, this, [this, reply]() {
                if (reply->error() == QModbusDevice::ProtocolError) {
                    statusBar()->showMessage(tr("Write response error: %1 (Mobus exception: 0x%2)")
                        .arg(reply->errorString()).arg(reply->rawResult().exceptionCode(), -1, 16),
                        5000);
                } else if (reply->error() != QModbusDevice::NoError) {
                    statusBar()->showMessage(tr("Write response error: %1 (code: 0x%2)").
                        arg(reply->errorString()).arg(reply->error(), -1, 16), 5000);
                }
                reply->deleteLater();
            });
        } else {
            // broadcast replies return immediately
            reply->deleteLater();
        }
    } else {
        statusBar()->showMessage(tr("Write error: ") + modbusDevice->errorString(), 5000);
    }
}

void M3KTE::onSelectedBoardChanged(int index)
{
    changeTable(index, ui->writeTable->currentIndex());
}

void M3KTE::onWriteTableChanged(int index)
{
    changeTable(ui->boardSelectBox->currentIndex(), index);
}

void M3KTE::changeTable(int board, int tabletype)
{

    if(tabletype==0)
    {
        ui->writeValueTable->setModel(Boards[board].ModbusModelCoil);
        int i = 0;
        for(;i<Boards[board].ModbusModelHoldingReg->rowCount();i++)
        {
            ui->writeValueTable->setRowHidden(i, ui->writeValueTable->model()->index(i, 0).parent(), false);
        }
        ui->writeValueTable->hideColumn(3);
        ui->writeValueTable->showColumn(2);
    }
    else
    {
        ui->writeValueTable->setModel(Boards[board].ModbusModelHoldingReg);
        if(tabletype==1)
        {
            Boards[board].ModbusModelHoldingReg->setStartAddress(0);
            int i = 0;
            for (;i<Boards[board].ModbusModelHoldingReg->rowCount()/2;i++) {
                ui->writeValueTable->setRowHidden(i, ui->writeValueTable->model()->index(i, 0).parent(), false);
            }
            for(;i<Boards[board].ModbusModelHoldingReg->rowCount();i++)
            {
                ui->writeValueTable->setRowHidden(i, ui->writeValueTable->model()->index(i, 0).parent(), true);
            }
        }
        else
        {
            Boards[board].ModbusModelHoldingReg->setStartAddress(Boards[board].ModbusModelHoldingReg->rowCount()/2);
            int i = 0;
            for (;i<Boards[board].ModbusModelHoldingReg->rowCount()/2;i++) {
                ui->writeValueTable->setRowHidden(i, ui->writeValueTable->model()->index(i, 0).parent(), true);
            }
            for(;i<Boards[board].ModbusModelHoldingReg->rowCount();i++)
            {
                ui->writeValueTable->setRowHidden(i, ui->writeValueTable->model()->index(i, 0).parent(), false);
            }
        }
        ui->writeValueTable->hideColumn(2);
        ui->writeValueTable->showColumn(3);
    }
}

QModbusDataUnit M3KTE::readRequest() const
{
    const auto table =
        static_cast<QModbusDataUnit::RegisterType>(ui->writeTable->currentData().toInt());

    int startAddress = 85 * (ui->writeTable->currentIndex()/2);
    Q_ASSERT(startAddress >= 0 && startAddress < 340);

    // do not go beyond 10 entries
    quint16 numberOfEntries = qMin((ushort)(85 - (ui->boardSelectBox->currentIndex()/3*20)), quint16(340 - startAddress));
    return QModbusDataUnit(table, startAddress, numberOfEntries);
}

QModbusDataUnit M3KTE::writeRequest() const
{
    const auto table =
        static_cast<QModbusDataUnit::RegisterType>(ui->writeTable->currentData().toInt());

    int startAddress = 85 * (ui->writeTable->currentIndex()/2);
    Q_ASSERT(startAddress >= 0 && startAddress < 340);

    // do not go beyond 10 entries
    quint16 numberOfEntries = qMin((ushort)(85 - (ui->boardSelectBox->currentIndex()/3*20)), quint16(340 - startAddress));
    return QModbusDataUnit(table, startAddress, numberOfEntries);
}

bool M3KTE::event(QEvent *event)
{
    if (event->type() == QEvent::User)
    {
        BoardIdHasBeenChanged* _event = static_cast<BoardIdHasBeenChanged*>(event);
        QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, 172, 1);
        _unit->setValue(0, _event->BoardNewID());
        modbusDevice->sendWriteRequest(*_unit, Boards[_event->BoardNum()].adr);
        if (auto *reply = modbusDevice->sendReadRequest(*_unit, Boards[_event->BoardNum()]._tmp_adr))
        {
        if (!reply->isFinished())
            connect(reply, &QModbusReply::finished, this, &M3KTE::onReadReady);
        else
            delete reply; // broadcast replies return immediately
        } else {
            errorAdrChange();
        }
        return true;
    }
    return QWidget::event(event);
}

void M3KTE::checkAdrChange()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    if (!reply)
    {
        errorAdrChange();
        return;
    }
    if (reply->error() == QModbusDevice::NoError) {
        for (int i = 0; i < 4; i++) {
            if(Boards[i]._tmp_adr == reply->serverAddress())
            {
                //OK
                Boards[i].adr = Boards[i]._tmp_adr;
                    reply->deleteLater();
                return;
            }
        }
        //ERROR
        errorAdrChange();
            reply->deleteLater();
        return;
    }
    errorAdrChange();
    reply->deleteLater();
}

void M3KTE::errorAdrChange()
{
    QMessageBox msgBox;
    msgBox.setText("Не удалось изменить адрес устройства.");
    msgBox.setStandardButtons(QMessageBox::Ok);
    msgBox.setDefaultButton(QMessageBox::Ok);
    int ret = msgBox.exec();
}

void M3KTE::onSpeedUpdate()
{
    //Отсутствие контроля записи регистра на плате.

    QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, 173, 1);
    _unit->setValue(0, m_deviceSettingsDialog->currentSpeed());
    for (int i = 0; i < 4; i++) {
        modbusDevice->sendWriteRequest(*_unit, Boards[i].adr);
    }

    modbusDevice->disconnectDevice();
    modbusDevice->setConnectionParameter(QModbusDevice::SerialBaudRateParameter,
                                         m_settingsDialog->UpdateBaud(m_deviceSettingsDialog->currentSpeed()));
    modbusDevice->connectDevice();
}

void M3KTE::onParityUpdate()
{
    //Отсутствие контроля записи регистра на плате.

    QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, 174, 1);
    switch (m_deviceSettingsDialog->currentParity())
    {
        case 0: //Нет контроля
        {
            _unit->setValue(0, 0x000);
            break;
        }
        case 1: //Четный
        {
            _unit->setValue(0, 0x0400);
            break;
        }
        case 2: //Нечетный
        {
            _unit->setValue(0, 0x0800);
            break;
        }
    }
    for (int i = 0; i < 4; i++) {
        modbusDevice->sendWriteRequest(*_unit, Boards[i].adr);
    }

    modbusDevice->disconnectDevice();
    modbusDevice->setConnectionParameter(QModbusDevice::SerialParityParameter,
                                         m_settingsDialog->UpdateParity(m_deviceSettingsDialog->currentParity()));
    modbusDevice->connectDevice();
}

bool M3KTE::pingNetworkDevices()
{
    int i=0;
    QTimer *timer = new QTimer(this);
    connect(timer, &QTimer::timeout, this, &M3KTE::timeForPingIsGone);
    timer->setSingleShot(true);
    QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 85, 1);
    int tmp_adr = 1;

    auto bar = new QProgressDialog(this);
    bar->setLabelText(tr("Поиск плат..."));
    bar->setCancelButton(nullptr);
    bar->setRange(0, 4);
    bar->setMinimumDuration(100);
    bar->setValue(i);


    for(i=0; i<1;)
    {
        bar->setValue(i);
        timerForPingSignal = false;
        timer->start(m_settingsDialog->settings().responseTime);
        auto *reply = modbusDevice->sendReadRequest(*_unit, tmp_adr);
        while(!reply->isFinished() && !timerForPingSignal)
        {
            QCoreApplication::processEvents();
        }
        if(timerForPingSignal)
        {


        }
        else
        {
            if(reply->error()==QModbusDevice::NoError)
            {
                timer->stop();
                Boards[i].adr = Boards[i]._tmp_adr = tmp_adr;
                i++;
            }
        }
        tmp_adr++;
        if(tmp_adr>=247)
        {
            //ERROR
            //OUT OF RANGE
            QMessageBox::warning(this, "Ошибка при сканировании сети.", QString("Выход за пределы допустимых адресов. Найдено %1 плат.").arg(i));
            bar->setValue(4);
            bar->deleteLater();
            onConnectClicked();
            return false;
        }
    }
    bar->setLabelText(tr("Сканирование регистров..."));
    bar->setValue(0);
    bar->setRange(0, 12);
    QModbusDataUnit* _unit_settings[3];
    _unit_settings[0] = new QModbusDataUnit(QModbusDataUnit::Coils, 0, 85);
    _unit_settings[1] = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, 0, 85);
    _unit_settings[2] = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, 85, 85);

    for(i=0; i<1; i++)
    {
        for (int j = 0; j<3; j++)
        {
            bar->setValue(i*3+j);
            timerForPingSignal = false;
            timer->start(m_settingsDialog->settings().responseTime);
            auto *reply = modbusDevice->sendReadRequest(*_unit_settings[j], Boards[i].adr);
            while(!reply->isFinished() && !timerForPingSignal)
            {
                QCoreApplication::processEvents();
            }
            if(timerForPingSignal)
            {
                QMessageBox::warning(this, "Ошибка при получении текущих настроек.", QString("Таймаут при опросе устройства %1 по адресу %2").arg(i).arg(Boards[i].adr));
                onConnectClicked();
                return false;
            }
            else
            {
                if(reply->error()==QModbusDevice::NoError)
                {
                    timer->stop();
                    stepForScanCurrentSettings(reply);
                }
                else
                {
                    QMessageBox::warning(this, "Ошибка при получении текущих настроек.", QString("Таймаут при опросе устройства %1 по адресу %2").arg(i).arg(Boards[i].adr));
                    bar->setValue(12);
                    onConnectClicked();
                    return false;
                }
            }
        }
    }
    beginScanBoards();
    bar->deleteLater();
    return true;

}

void M3KTE::timeForPingIsGone()
{
    timerForPingSignal=true;
}

void M3KTE::beginScanBoards()
{
    firstBoardScan();
    //secondBoardScan();
    //thirdBoardScan();
    //fourthBoardScan();
    return;
}

void M3KTE::firstBoardScan()
{
    if (!modbusDevice)
        return;

        QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 0, 85);
        statusBar()->clearMessage();

        if (auto *reply = modbusDevice->sendReadRequest(*_unit, Boards[0].adr)) {
            if (!reply->isFinished())
                connect(reply, &QModbusReply::finished, this, &M3KTE::firstBoardReady);
            else
                delete reply; // broadcast replies return immediately
        } else {
            QMessageBox::warning(this, QString("Ошибка при опросе платы #%1").arg(1), QString(tr("Read error: ") + modbusDevice->errorString()));
            statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
        }
}

void M3KTE::secondBoardScan()
{
    if (!modbusDevice)
        return;

            QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 0, 85);
        statusBar()->clearMessage();

        if (auto *reply = modbusDevice->sendReadRequest(*_unit, Boards[1].adr)) {
            if (!reply->isFinished())
                connect(reply, &QModbusReply::finished, this, &M3KTE::secondBoardReady);
            else
                delete reply; // broadcast replies return immediately
        } else {
            QMessageBox::warning(this, QString("Ошибка при опросе платы #%1").arg(2), QString(tr("Read error: ") + modbusDevice->errorString()));
            statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
        }
}

void M3KTE::thirdBoardScan()
{
    if (!modbusDevice)
        return;

            QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 0, 85);
        statusBar()->clearMessage();

        if (auto *reply = modbusDevice->sendReadRequest(*_unit, Boards[2].adr)) {
            if (!reply->isFinished())
                connect(reply, &QModbusReply::finished, this, &M3KTE::thirdBoardReady);
            else
                delete reply; // broadcast replies return immediately
        } else {
            QMessageBox::warning(this, QString("Ошибка при опросе платы #%1").arg(3), QString(tr("Read error: ") + modbusDevice->errorString()));
            statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
        }
}

void M3KTE::fourthBoardScan()
{
    if (!modbusDevice)
        return;

            QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 0, 85);
        statusBar()->clearMessage();

        if (auto *reply = modbusDevice->sendReadRequest(*_unit, Boards[3].adr)) {
            if (!reply->isFinished())
                connect(reply, &QModbusReply::finished, this, &M3KTE::fourthBoardReady);
            else
                delete reply; // broadcast replies return immediately
        } else {
            QMessageBox::warning(this, QString("Ошибка при опросе платы #%1").arg(4), QString(tr("Read error: ") + modbusDevice->errorString()));
            statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
        }

}

void M3KTE::firstBoardReady()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    displayResultOfScan(reply, 0);
    reply->deleteLater();
    Boards[0].boardScanners->start(m_deviceSettingsDialog->currentBoardTimer(0));
}

void M3KTE::secondBoardReady()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    displayResultOfScan(reply, 1);
    reply->deleteLater();
    Boards[1].boardScanners->start(m_deviceSettingsDialog->currentBoardTimer(1));
}

void M3KTE::thirdBoardReady()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    displayResultOfScan(reply, 2);
    reply->deleteLater();
    Boards[2].boardScanners->start(m_deviceSettingsDialog->currentBoardTimer(2));
}

void M3KTE::fourthBoardReady()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    displayResultOfScan(reply, 3);
    reply->deleteLater();
    Boards[3].boardScanners->start(m_deviceSettingsDialog->currentBoardTimer(3));
}

void M3KTE::displayResultOfScan(QModbusReply *reply, int boardID)
{
    if (!reply)
        return;

    if (reply->error() == QModbusDevice::NoError) {

        const QModbusDataUnit unit = reply->result();
        bool W_Flag = false;
        bool A_Flag = false;
        if(unit.startAddress() != 0 || unit.valueCount() != 85)
        {
            //ERROR
            reply->deleteLater();
            QMessageBox::warning(this, QString("Ошибка при опросе платы #%1").arg(boardID), QString("Принятый ответ: Стартовый адрес %1, Количество элементов %2").arg(unit.startAddress()).arg(unit.valueCount()));
            return;
        }

        for(int i = unit.startAddress(), total = int(unit.valueCount()); i < total; ++i)
        {
            //QErrorMessage::showMessage()
            //if(Boards[boardID].ModbusModelCoil->data(Boards[boardID].ModbusModelCoil->index(i, 2), Qt::CheckStateRole).Bool != 0)
            if(Boards[boardID].ModbusModelCoil->get_coil(Boards[boardID].ModbusModelCoil->index(i, 2))==true)
            {
                int j = 0;
                if(Boards[boardID].ModbusModelHoldingReg->get_holreg(Boards[boardID].ModbusModelHoldingReg->index(85+i, 3)) > unit.value(i))
                {
                    j = 1;
                    m[i+boardID*85]->setStatusTip(QString("П%1 ТЭ%2: Аварийный уровень напряжения.").arg(QString::number(boardID+1), QString::number(i%85)));
                    m[i+boardID*85]->setWhatsThis(QString("П%1 ТЭ%2: Аварийный уровень напряжения.").arg(QString::number(boardID+1), QString::number(i%85)));
                    A_Flag = true;
                }
                else if(Boards[boardID].ModbusModelHoldingReg->get_holreg(Boards[boardID].ModbusModelHoldingReg->index(i, 3)) > unit.value(i))
                {
                    j = 2;
                    m[i+boardID*85]->setStatusTip(QString("П%1 ТЭ%2: Предупредительный уровень напряжения.").arg(QString::number(boardID+1), QString::number(i%85)));
                    m[i+boardID*85]->setWhatsThis(QString("П%1 ТЭ%2: Предупредительный уровень напряжения.").arg(QString::number(boardID+1), QString::number(i%85)));
                    W_Flag = true;
                }
                else
                {
                    j = 3;
                    m[i+boardID*85]->setStatusTip(QString("П%1 ТЭ%2: Уровень напряжения в норме.").arg(QString::number(boardID+1), QString::number(i%85)));
                    m[i+boardID*85]->setWhatsThis(QString("П%1 ТЭ%2: Уровень напряжения в норме.").arg(QString::number(boardID+1), QString::number(i%85)));
                }
                m[i+boardID*85]->setValue(j);
                QString style_fc = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(j*50-50) + ", 255, 255, 100%);} ";
                m[i+boardID*85]->setStyleSheet(style_fc);
            }
            else
            {
                m[i+boardID*85]->setStatusTip(QString("П%1 ТЭ%2: Топливный Элемент не учитывается.").arg(QString::number(boardID+1), QString::number(i%85)));
                m[i+boardID*85]->setWhatsThis(QString("П%1 ТЭ%2: Топливный Элемент не учитывается.").arg(QString::number(boardID+1), QString::number(i%85)));
                QString style_fc_off = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(30) + ", 30, 30, 30%);} ";
                m[i+boardID*85]->setStyleSheet(style_fc_off);
            }
        }
        if(A_Flag)
            statusM3KTE.Accidents[boardID] = true;
        else
             statusM3KTE.Accidents[boardID] = false;
        if(W_Flag)
            statusM3KTE.Warnings[boardID] = true;
        else
            statusM3KTE.Warnings[boardID] = false;

        ui->BSM_Warning->setChecked(false);
        ui->BSM_Accident->setChecked(false);
        ui->BSM_WorkInProgress->setChecked(true);
        for(int i = 0; i < 4; i++)
        {
            if(statusM3KTE.Accidents[i])
            {
                ui->BSM_WorkInProgress->setChecked(false);
                ui->BSM_Warning->setChecked(false);
                ui->BSM_Accident->setChecked(true);
                break;
            }
            if(statusM3KTE.Warnings[i])
            {
                ui->BSM_WorkInProgress->setChecked(false);
                ui->BSM_Accident->setChecked(false);
                ui->BSM_Warning->setChecked(true);
            }
        }
    }   else if (reply->error() == QModbusDevice::ProtocolError) {
        statusBar()->showMessage(tr("Read response error: %1 (Mobus exception: 0x%2)").
                                    arg(reply->errorString()).
                                    arg(reply->rawResult().exceptionCode(), -1, 16), 5000);
    } else {
        statusBar()->showMessage(tr("Read response error: %1 (code: 0x%2)").
                                    arg(reply->errorString()).
                                    arg(reply->error(), -1, 16), 5000);
    }
    reply->deleteLater();
}

void M3KTE::stepForScanCurrentSettings(QModbusReply *reply)
{
        if (reply->error() == QModbusDevice::NoError) {
            const QModbusDataUnit unit = reply->result();
            int Adr = 255;
            for(int i = 0; i < 4; i++)
            {
                if(Boards[i].adr==reply->serverAddress())
                {
                    Adr = i;
                    break;
                }
            }
            for (int i = unit.startAddress(), total = int(unit.valueCount()); i < total; ++i) {
                //ui->readValue->addItem(entry);
                if(unit.registerType() == QModbusDataUnit::Coils)
                {
                    //QStandardItem *item = ui->writeValueTable->model()->item
                    if(unit.value(i)==1)
                        Boards[Adr].ModbusModelCoil->setData(ui->writeValueTable->model()->index(i, 2), Qt::Checked, Qt::CheckStateRole);
                    else
                       Boards[Adr].ModbusModelCoil->setData(ui->writeValueTable->model()->index(i, 2), Qt::Unchecked, Qt::CheckStateRole);
                }
                else if(unit.registerType() == QModbusDataUnit::HoldingRegisters)
                {
                    Boards[Adr].ModbusModelHoldingReg->setData(ui->writeValueTable->model()->index(i, 3), QString::number(unit.value(i), 16), Qt::EditRole);
                }
            }
        } else if (reply->error() == QModbusDevice::ProtocolError) {
            statusBar()->showMessage(tr("Read response error: %1 (Mobus exception: 0x%2)").
                                        arg(reply->errorString()).
                                        arg(reply->rawResult().exceptionCode(), -1, 16), 5000);
        } else {
            statusBar()->showMessage(tr("Read response error: %1 (code: 0x%2)").
                                        arg(reply->errorString()).
                                        arg(reply->error(), -1, 16), 5000);
        }

        reply->deleteLater();
}
